Take the 2-minute tour ×
Server Fault is a question and answer site for professional system and network administrators. It's 100% free, no registration required.

I was trying to make an init script for my debian install for supervisor.

insserv: Service \$remote_fs has to be enabled to start service supervisor                              
insserv: Service \$syslog has to be enabled to start service supervisor                                 
insserv: exiting now!                                                                                   
update-rc.d: error: insserv rejected the script header 

The full contents of the init script is here:

#! /bin/sh
### BEGIN INIT INFO
# Provides:          supervisor
# Required-Start:    \$remote_fs \$syslog
# Required-Stop:     \$remote_fs \$syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Supervisor
# Description:       Supervisor service
### END INIT INFO

#
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Supervisor Service"
NAME=supervisord
DAEMON=/usr/local/bin/\$NAME
DAEMON_ARGS="-c /etc/supervisord.conf"
PIDFILE=/var/run/\$NAME.pid
SCRIPTNAME=/etc/init.d/\$NAME

# Exit if the package is not installed
[ -x "\$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/\$NAME ] && . /etc/default/\$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
        # Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        start-stop-daemon --start --quiet --pidfile \$PIDFILE --exec \$DAEMON --test > /dev/null \
                || return 1
        start-stop-daemon --start --quiet --pidfile \$PIDFILE --exec \$DAEMON -- \
                \$DAEMON_ARGS \
                || return 2
        # Add code here, if necessary, that waits for the process to be ready
        # to handle requests from services started subsequently which depend
        # on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
        # Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile \$PIDFILE --name \$NAME
        RETVAL="\$?"
        [ "\$RETVAL" = 2 ] && return 2
        # Wait for children to finish too if this is a daemon that forks
        # and if the daemon is only ever run from this initscript.
        # If the above conditions are not satisfied then add some other code
        # that waits for the process to drop all resources that could be
        # needed by services started subsequently.  A last resort is to
        # sleep for some time.
        start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec \$DAEMON
        [ "\$?" = 2 ] && return 2
        # Many daemons don't delete their pidfiles when they exit.
        rm -f \$PIDFILE
        return "\$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
        #
        # If the daemon can reload its configuration without
        # restarting (for example, when it is sent a SIGHUP),
        # then implement that here.
        #
        start-stop-daemon --stop --signal 1 --quiet --pidfile \$PIDFILE --name \$NAME
        return 0
}

case "\$1" in
  start)
        [ "\$VERBOSE" != no ] && log_daemon_msg "Starting \$DESC" "\$NAME"
        do_start
        case "\$?" in
                0|1) [ "\$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "\$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  stop)
        [ "\$VERBOSE" != no ] && log_daemon_msg "Stopping \$DESC" "\$NAME"
        do_stop
        case "\$?" in
                0|1) [ "\$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "\$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  status)
        status_of_proc "\$DAEMON" "\$NAME" && exit 0 || exit \$?
        ;;
  #reload|force-reload)
        #
        # If do_reload() is not implemented then leave this commented out
        # and leave 'force-reload' as an alias for 'restart'.
        #
        #log_daemon_msg "Reloading \$DESC" "\$NAME"
        #do_reload
        #log_end_msg \$?
        #;;
  restart|force-reload)
        #
        # If the "reload" option is implemented then remove the
        # 'force-reload' alias
        #
        log_daemon_msg "Restarting \$DESC" "\$NAME"
        do_stop
        case "\$?" in
          0|1)
                do_start
                case "\$?" in
                        0) log_end_msg 0 ;;
                        1) log_end_msg 1 ;; # Old process is still running
                        *) log_end_msg 1 ;; # Failed to start
                esac
                ;;
          *)
                # Failed to stop
                log_end_msg 1
                ;;
        esac
        ;;
  *)
        #echo "Usage: \$SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
        echo "Usage: \$SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
        exit 3
        ;;
esac
:

Can anyone please tell me where this error is coming from? I've not seen this kind of error before.

This is how I use this script:

ln -s $HOME/supervisord.conf /etc/supervisord.conf
ln -s $HOME/init/supervisor /etc/init.d/supervisor
chmod 755 /etc/init.d/supervisor
update-rc.d supervisor defaults
share|improve this question
    
Could you tell us how exactly you call insserv? Your script header works for me. –  Marcus Rickert Nov 24 '13 at 20:13
    
I have updated my question to include how I use this script. I don't directly call insserv. –  Jimmy Nov 24 '13 at 20:55
add comment

1 Answer 1

up vote 1 down vote accepted

All your $ are escaped: \$.

Don't do that, youneed the variables, not the litteral dollar signs... ;)

share|improve this answer
    
Ah good spot. I'm new to this, do I want to be finding and replacing every instance of \$ and replace with $ –  Jimmy Nov 24 '13 at 21:24
    
@Jimmy yes you do, otherwise the LSB header (the Required-* lines especially) is not parse-able by insserv. But also the other occurrences are "wrong". –  zhenech Nov 24 '13 at 21:33
add comment

Your Answer

 
discard

By posting your answer, you agree to the privacy policy and terms of service.

Not the answer you're looking for? Browse other questions tagged or ask your own question.